#include <windows.h>
#include <iostream>

#include "SiUSBXp.h"

const DWORD IN_PACKAGE_SIZE = 13;		//   
const DWORD OUT_PACKAGE_SIZE = 1;		//   

const UCHAR REF_MARK_FLAG = 1 << 7;		//    
const UCHAR VCC_FLAG	  = 1 << 6;		//   

const UCHAR PACKAGE_REQUEST =	  0x33;	//   
const UCHAR DROP_ABS_COORDINATE = 0x31;	//    
const UCHAR DROP_REL_COORDINATE = 0x30;	//    

const DWORD ABS_COORD_NUM = 0;			//     
const DWORD REL_COORD_NUM = 1;			//     
const DWORD REF_COORD_NUM = 2;			//      

const DWORD STATUS_OFFSET = 0;			//     

//
//     
// <num>   <buffer>.
//
int GetInt32(UCHAR* buffer, int num)
{
	int* to_int = 
		reinterpret_cast<int*>(buffer + 1);

	return to_int[num];
}

int main()
{
	//    .
	setlocale(LC_ALL, "russian");

	//
	//      
	//       .
	//

	DWORD numDevices = 0;
	SI_GetNumDevices(&numDevices);

	if (numDevices == 0)
	{
		std::cout << "    USB-." << std::endl;
		return 1;
	}
	
	//
	//   USB-  
	//   .
	//

	HANDLE usb = 0;
	DWORD usbNum = 0;
	
	if (SI_Open(usbNum, &usb) != SI_SUCCESS)
	{
		std::cout << "     USB-." << std::endl;
		return 2;
	}

	//
	//    
	//      
	//   /.
	//

	const DWORD STANDART_TIMEOUT = 500; // 
	SI_SetTimeouts(STANDART_TIMEOUT, STANDART_TIMEOUT);
	
	SI_FlushBuffers(usb, 1, 1);

	UCHAR buffer[IN_PACKAGE_SIZE];
	DWORD byteCount = 0;
	
	//
	//     
	//    .
	// 

	UCHAR command = DROP_ABS_COORDINATE;
	SI_Write(usb, &command, OUT_PACKAGE_SIZE, &byteCount);
	
	command = DROP_REL_COORDINATE;
	SI_Write(usb, &command, OUT_PACKAGE_SIZE, &byteCount);

	char resume = 'y';

	//
	//  .
	//

	command = PACKAGE_REQUEST;
	while (resume != 'n')
	{
		//
		//       .
		//    ,     
		//    VCC_FLAG,  .
		//

		if (SI_Write(usb, &command, OUT_PACKAGE_SIZE, &byteCount) == SI_SUCCESS &&
			byteCount == OUT_PACKAGE_SIZE)
		{
			if (SI_Read(usb, buffer, IN_PACKAGE_SIZE, &byteCount) == SI_SUCCESS &&
				byteCount == IN_PACKAGE_SIZE)
			{
				if ((buffer[STATUS_OFFSET] & VCC_FLAG) == 0)
				{
					std::cout << " : " 
							  << GetInt32(buffer, ABS_COORD_NUM) << std::endl
							  << " : " 
							  << GetInt32(buffer, REL_COORD_NUM) << std::endl
							  << "   : " 
							  << GetInt32(buffer, REF_COORD_NUM) << std::endl;

					//        .
					if ((buffer[STATUS_OFFSET] & REF_MARK_FLAG) != 0)
					{
						std::cout << "  ." << std::endl;
					}
				}
				else // VCC_FLAG
				{
					std::cout << "    ." << std::endl;
				}
			}
			else // SI_Read =(
			{
				std::cout << "  ." << std::endl;
			}
		}
		else // SI_Write =(
		{
			std::cout << "  ." << std::endl;
		}

		std::cout << " ? (y/n): "; std::cin >> resume; 
		std::cout << std::endl;
	}

	//  .
	SI_Close(usb);

	return 0;
}